<h4>Neon Timeseries Editor</h4>
<hr>
<!-- Databases -->
<div class="input-group mb-3">
    <div class="input-group-prepend">
        <span class="input-group-text">Databases</span>
    </div>
    <select class="form-control" [ngModel]="selectedDb" (ngModelChange)="onDbSelected($event)" [disabled]="!isNeonReady">
        <option [ngValue]="null" disabled selected="true">—</option>
        <option *ngFor="let dbName of dbNames" [ngValue]="dbName">{{ dbName }}</option>
    </select>
</div>
<!-- Tables -->
<div class="input-group mb-3">
    <div class="input-group-prepend">
        <span class="input-group-text">Tables</span>
    </div>
    <select class="form-control" [ngModel]="selectedTable" (ngModelChange)="onTableSelected($event)" [disabled]="!this.tableNames.length || !isNeonReady">
        <option [ngValue]="null" disabled selected>—</option>
        <option *ngFor="let tableName of tableNames" [ngValue]="tableName">{{ tableName }}</option>
    </select>
</div>
<!-- Date Field -->
<div class="input-group mb-3">
    <div class="input-group-prepend">
        <span class="input-group-text">Date Field</span>
    </div>
    <select class="form-control" [ngModel]="dateField" (ngModelChange)="onDateFieldSelected($event)" [disabled]="!hasFields()">
        <option [ngValue]="null">—</option>
        <option *ngFor="let fieldName of fieldNames" [value]="fieldName">{{ fieldName }}</option>
    </select>
</div>
<div class="input-group mb-3">
    <div class="input-group-prepend">
        <span class="input-group-text">Date Granularity</span>
    </div>
    <select class="form-control" [ngModel]="granularity" (ngModelChange)="onGranularitySelected($event)" [disabled]="!hasFields()">
        <option value="null">—</option>
        <option value="year">YEAR</option>
        <option value="month">MONTH</option>
        <option value="dayOfMonth">DAY</option>
        <option value="hour">HOUR</option>
    </select>
</div>
<hr>
<h5>Aggregation</h5>
<div class="input-group mb-3">
    <div class="input-group-prepend">
        <span class="input-group-text">Group By</span>
    </div>
    <select class="form-control" [ngModel]="selectedGroupByField" (ngModelChange)="onAggGroupByFieldSelected($event)" [disabled]="!hasFields()">
        <option [ngValue]="null">—</option>
        <option *ngFor="let fieldName of fieldNames" [value]="fieldName">{{ fieldName }}</option>
    </select>
</div>
<hr>
<h5>Date Filtering </h5>
<!-- Date Filtering -->
<table class="table table-bordered">
    <thead>
        <tr>
            <th class="col-xs-4">Date Field</th>
            <th>From</th>
            <th>To</th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>
                <select class="form-control" [ngModel]="selectedTimeFilterField" (ngModelChange)="onTimeFilterFieldSelected($event)" [disabled]="!hasFields()">
                    <option [ngValue]="null" disabled>—</option>
                    <option *ngFor="let fieldName of fieldNames" [value]="fieldName">{{ fieldName }}</option>
                </select>
            </td>
            <td>
                <input type="text" [ngModel]="selectedTimeFilterFrom" (ngModelChange)="onTimeFilterFromSelected($event)" placeholder="From Date" class="form-control" bsDatepicker [bsConfig]="bsConfig" [disabled]="!hasFields()" >
            </td>
            <td>
                <input type="text" [ngModel]="selectedTimeFilterTo" (ngModelChange)="onTimeFilterToSelected($event)" placeholder="To Date" class="form-control" bsDatepicker [bsConfig]="bsConfig" [disabled]="!hasFields()">       
            </td>
        </tr>
    </tbody>
</table>

<h5>Filtering (AND)</h5>
<!-- Filtering -->
<table class="table table-bordered">
    <thead>
        <tr>
            <th class="col-xs-4">Field</th>
            <th>Operator</th>
            <th>Value</th>
            <th class="col-xs-2">Remove</th>
        </tr>
    </thead>
    <tbody>
        <tr *ngFor="let filter of filters; let i = index;">
            <td>
                <select class="form-control" [(ngModel)]="filter.field" (ngModelChange)="onFilterFieldSelected($event)">
                    <option [ngValue]="null" disabled>—</option>
                    <option *ngFor="let fieldName of fieldNames" [value]="fieldName">{{ fieldName }}</option>
                </select>
            </td>
            <td>
                <select class="form-control" [(ngModel)]="filter.operator" (ngModelChange)="onFilterOperatorSelected($event)">
                    <option value="=">=</option>
                    <option value="!=">!=</option>
                    <option value=">">&gt;</option>
                    <option value="<">&lt;</option>
                    <option value=">=">&gt;=</option>
                    <option value="<=">&lt;=</option>
                    <option value="contains">contains</option>
                    <option value="not contains">not contains</option>
                </select>
            </td>
            <td>
                <input class="form-control" [(ngModel)]="filter.value" (ngModelChange)="onFilterValueSelected($event)">                
            </td>
            <td>
                <button class="btn btn-block btn-danger" (click)="removeFilter(i)">Remove</button>
            </td>
        </tr>
        <tr *ngIf="!filters.length">
            <td colspan="4" class="text-center">No Filters</td>
        </tr>
        <tr>
            <td colspan="4">
                <button class="btn btn-block btn-default" (click)="addFilter()" [disabled]="!hasFields()">Add Filter</button>
            </td>
        </tr>
    </tbody>
</table>
<hr>
<h5>EWMA Trend</h5>
<div class="input-group mb-3">
    <div class="input-group-prepend">
        <span class="input-group-text">Alpha</span>
    </div>
    <input class="form-control" placeholder="Select a value between 0 and 1, e.g (0.5)" [ngModel]="ewmaAlpha" (ngModelChange)="onEwmaAlphaSelected($event)"  [disabled]="!hasFields()">   
</div>
<hr>
<h5>Limit</h5>
<select class="form-control" [(ngModel)]="selectedLimit" [disabled]="!canSendQuery()">
    <option value="100">100</option>
    <option value="1000">1,000</option>
    <option value="5000">5,000</option>
    <option value="10000">10,000</option>
    <option value="50000">50,000</option>
</select>
<hr>
<!-- Response as JSON (Test) -->
<textarea class="form-control" rows="8" placeholder="Response..." [disabled]="!selectedTable">{{ lastResponse | json }}</textarea>
<hr>
<button class="btn btn-block btn-success" (click)="sendQuery()" [disabled]="!canSendQuery()" *ngIf="isNeonReady">
    Send Query
    <i class="fa fa-spinner fa-spin" *ngIf="processing"></i>
</button>
<!-- Connection -->
<button class="btn btn-block btn-success" (click)="connectToNeon()" *ngIf="!isNeonReady" [disabled]="processing">
    Connect to Neon Server
    <i class="fa fa-spinner fa-spin" *ngIf="processing"></i>
</button>